package  
{
	import net.flashpunk.Entity;
	import net.flashpunk.FP;
	/**
	 * ...
	 * @author Lucas Lundy
	 */
	public class CameraCtrl extends Entity
	{
		public static const MOVE_TO_RUNNER:int = 1;
		public static const FOLLOW_RUNNER:int = 2;
		public static const MOVING:int = 3;
		public static const FOLLOW_ENEMY:int = 4;
		public static const MOVE_TO_NEW_SPAWN:int = 5;
		public static const WAIT_FOR_DEATH:int = 6;
		public static const FOLLOW_TO_GOAL:int = 7;
		
		
		public var curState:int;
		
		protected var xVec:int;
		protected var yVec:int;
		protected var speed:int = 15;
		
		protected var destX:int;
		protected var destY:int;
		
		protected var startTime:int;
		protected var FollowRunDur:int = 180;
		protected var wait4DeathDur:int = 120;
		
		protected var curEnemy:EnemyBase;
		protected var lastXEnemy:int;
		protected var enemyChange:int;
		protected var theGameScreen:ScreenGame;
		
		public function CameraCtrl( screen:ScreenGame ) 
		{
			x = 0; y = 0; 
			theGameScreen = screen;
			moveToRunner();
		}
		
		override public function update():void {
			if (curState == MOVE_TO_RUNNER) {
				if (isPastPoint()) {
					curState = FOLLOW_RUNNER;
					xVec = 0;
					yVec = 0;
					startTime = 0;
				}
			}else if (curState == FOLLOW_RUNNER) {
				x = ScreenGame.theRunner.x;
				y = ScreenGame.theRunner.y - 192;
				if (startTime >= 180) {
					moveToNextSpawn();
				}
				else {
					++startTime;
				}
			}else if (curState == MOVE_TO_NEW_SPAWN) {
				if (isPastPoint()) {
					//ScreenGame.active = true;
					xVec = 0;
					yVec = 0;
					//Make visable Enemy Selection
					theGameScreen.selectEnemy();
					trace("Make Visable Enemy Selection");
				}
			}else if (curState == FOLLOW_ENEMY) {
				//Watach for Runner Passing the Enemy
				if (curEnemy.getLifeState() == EnemyBase.DOGED){
					moveToNextSpawn();
				}else if (curEnemy.getLifeState() != EnemyBase.ALIVE ) {//Watch for Enemy Death
					startTime = 0;
					curState =  WAIT_FOR_DEATH;
				}
				/*
				x = curEnemy.x;
				enemyChange = curEnemy.x - lastXEnemy;
				if (curEnemy.x < x + 100 ||  curEnemy.x > x + 700) {
					x += enemyChange;
				}*/
				lastXEnemy = curEnemy.x;
			}else if ( curState == WAIT_FOR_DEATH ) {
				if (startTime >= wait4DeathDur) {
					moveToNextSpawn();
				}
				else
					++startTime;
			}else if ( curState == FOLLOW_TO_GOAL) {
				x = ScreenGame.theRunner.x - 400;
				y = ScreenGame.theRunner.y - 192;
			}
			
			x += xVec;
			y += yVec;
			
			FP.camera.x = x;
			FP.camera.y = y;
		}
		
		protected function moveToNextSpawn():void {
			curState = MOVE_TO_NEW_SPAWN;
			destX = ScreenGame.theRunner.x + 1000;
			setCourse(destX, destY);
			if (destX > ScreenGame.theGoal.x) {
				curState = FOLLOW_TO_GOAL;
			}else {
				ScreenGame.active = false;
			}
		}
		
		protected function moveToRunner():void {
			destX = ScreenGame.theRunner.x;
			destY = ScreenGame.theRunner.y - 192;
			
			setCourse(destX, destY);
			
			curState = MOVE_TO_RUNNER;
			
		}
		
		protected function isPastPoint():Boolean {
			if (xVec > 0) {
				if (x >= destX)
					return true;
			}else {
				if (x <= destX)
					return true;
			}
			return false;
		}
		
		protected function setCourse(playerX:Number, playerY:Number ):void{
			//var playerX:Number;
			//var playerY:Number;
			
			var xSpeed:Number = 0;
			var ySpeed:Number = 0;
			
			var diffX:Number;
			var diffY:Number;
			var c:Number;
			
            diffX = Math.abs(x - playerX);
            diffY = Math.abs(y - playerY);
            c = Math.sqrt(Math.pow(diffX, 2) + Math.pow(diffY, 2));
			
			
            //Find speeds
            if (diffX > diffY)
            {
                ySpeed = (diffY * speed) / c;
                xSpeed = Math.sqrt(Math.pow(speed, 2) - Math.pow(ySpeed, 2));
            }
            else
            {
                xSpeed = (diffX * speed) / c;
                ySpeed = Math.sqrt(Math.pow(speed, 2) - Math.pow(xSpeed, 2));
            }
            //Find signs
            if (x > playerX)
            {
                xSpeed = -xSpeed;
            }
            if (y > playerY)
            {
                ySpeed = -ySpeed;
            }
            //set speeds

            xVec = xSpeed;
            yVec = ySpeed;
        }
		
		//Interface function
		public function enemyCreated( newEnemy:EnemyBase ):void {
			this.curEnemy = newEnemy;
			this.lastXEnemy = newEnemy.x;
			this.curState = FOLLOW_ENEMY;
		}
	}

}