package  
{
	import net.flashpunk.FP;
	import net.flashpunk.graphics.Image;
	import net.flashpunk.masks.Pixelmask;
	import net.flashpunk.utils.Input;
	import net.flashpunk.utils.Key;
	import net.flashpunk.Sfx;
	/**
	 * ...
	 * @author Lucas Lundy
	 */
	public class EnemyBat extends EnemyBase
	{
		
		
		public var lifeState:int = ALIVE;
		
		[Embed (source = 'assets/Bat.png')] private const BAT:Class;
		[Embed (source = 'assets/BatDeath.png')] private const BATDEATH:Class;
		[Embed(source = 'assets/HitGround.mp3')] private const HITGROUND:Class;
		
		public var hitGroundsfx:Sfx = new Sfx(HITGROUND);
		
		protected var xVec:int;
		protected var yVec:int;
		protected var xAccel:int;
		protected var yAccel:int = 1;
		protected var speed:int = 5;
		
		protected var timeStart:int = 0;
		protected var DeathDur:int = 120;
		
		public function EnemyBat( spawnX:int, spawnY:int) 
		{
			x = spawnX; y = spawnY;
			graphic = new Image(BAT);
			
			type = "enemy";
			
			mask = new Pixelmask(BAT);
		}
		
		override public function update():void {
			if(lifeState == ALIVE){
			xVec = 0;
			if (Input.check(Key.LEFT)) {
					//if (x > 0)
					//{
						xVec = -5;
					//}
				}
				if (Input.check(Key.RIGHT)) {
					//if (x < 775)
					//{
						xVec = 5;
					//}
				}
				if (Input.check(Key.DOWN)) {
					//if (y < 575)
					//{
						yVec += 5;
					//}
				}
				if (Input.check(Key.UP)) {
					//if (y > 0)
					//{
						yVec -= 5;
					//}
				}
				
				yVec += yAccel;
				if (yVec > 10)
					yVec  = 10;
				if (yVec < -10)
					yVec = -10;
				
				x += xVec;
				y += yVec;
				
				//Collide with ground
				var b:Ground = collide('ground', x, y) as Ground;
				// Check if b has a value (true if a Bullet was collided with).
				if (b)
				{
					hitGound();
					hitGroundsfx.play();
					//FP.world = new screenStart;
				}
				
				if (ScreenGame.theRunner.x > x + 250) {
					missedPlayer();
				}
				
			}else if(lifeState == DYING) {
				if (timeStart >= DeathDur)
					lifeState = DEAD;
				else
					++timeStart;
			}else if (lifeState == DEAD) {
				world.remove(this);
			}
		}
		
		public function missedPlayer():void {
			lifeState = DOGED;
			timeStart = 0;
			--ScreenGame.lives;
		}
		
		override public function hitGound():void {
			graphic = new Image(BATDEATH);
			lifeState = DYING;
			timeStart = 0;
			--ScreenGame.lives;
		}
		
		override public function hitPlayer():void {
			graphic = new Image(BATDEATH);
			lifeState = DYING;
			timeStart = 0;
			//--ScreenGame.lives;
		}
		
		override public function getLifeState():int {
			return lifeState;
		}
	}

}