package  
{
	import net.flashpunk.Entity;
	import net.flashpunk.graphics.Image;
	import net.flashpunk.masks.Pixelmask;
	import net.flashpunk.utils.Input;
	import net.flashpunk.utils.Key;
	/**
	 * ...
	 * @author Lucas Lundy
	 */
	public class EnemyGooba extends EnemyBase
	{
		[Embed (source = 'assets/gumba.png')] private const GOOBA:Class;
		[Embed (source = 'assets/gumbaDeath.png')] private const GOOBA_DEATH:Class;
		
		public var lifeState:int = ALIVE;
		protected var xVec:int;
		protected var yVec:int;
		protected var xAccel:int;
		protected var yAccel:int = 1;
		protected var speed:int = 3;
		
		protected var timeStart:int = 0;
		protected var DeathDur:int = 120;
		
		public function EnemyGooba( spawnX:int, spawnY:int) 
		{
			x = spawnX; y = spawnY;
			graphic = new Image(GOOBA);
			mask = new Pixelmask(GOOBA);
			
			type = 'enemy';
		}
		
		override public function update():void {
			if(lifeState == ALIVE){
			xVec = 0;
			if (Input.check(Key.LEFT)) {
					//if (x > 0)
					//{
						xVec = -speed;
					//}
				}
				if (Input.check(Key.RIGHT)) {
					//if (x < 775)
					//{
						xVec = speed;
					//}
				}
				
				x += xVec;
				y += yVec;
				
				//Collide with ground
				/*var b:Ground = collide('ground', x, y) as Ground;
				// Check if b has a value (true if a Bullet was collided with).
				if (b)
				{
					hitPlayer();
					//FP.world = new screenStart;
				}*/
				
				if (ScreenGame.theRunner.x > x + 250) {
					missedPlayer();
				}
				
			}else if(lifeState == DYING) {
				if (timeStart >= DeathDur)
					lifeState = DEAD;
				else
					++timeStart;
			}else if (lifeState == DEAD) {
				world.remove(this);
			}
		}
		
		public function missedPlayer():void {
			lifeState = DOGED;
			timeStart = 0;
			//--ScreenGame.lives;
		}
		
		override public function hitGound():void {
			graphic = new Image(GOOBA_DEATH);
			lifeState = DYING;
			timeStart = 0;
			--ScreenGame.lives;
		}
		
		override public function hitPlayer():void {
			graphic = new Image(GOOBA_DEATH);
			lifeState = DYING;
			timeStart = 0;
			//--ScreenGame.lives;
		}
		
		override public function getLifeState():int {
			return lifeState;
		}
	}

}