package  
{
	import net.flashpunk.utils.Input;
	import net.flashpunk.utils.Key;
	import net.flashpunk.Entity;
	import net.flashpunk.graphics.Image;
	import net.flashpunk.Sfx;
	/**
	 * ...
	 * @author Lucas Lundy
	 */
	public class EnemySelector extends Entity
	{
		[Embed (source = 'assets/SelectorBKG.png')] private const BKG:Class;
		[Embed(source = 'assets/spawn.mp3')] private const SPAWN:Class;
		
		public var spawn:Sfx = new Sfx(SPAWN);
		
		protected var btnBat:btnBatSelect;
		protected var btnGooba:btnGoobaSelect;
		protected var myCamera:CameraCtrl;
		
		private var started:Boolean = false;
		
		public function EnemySelector(cam:CameraCtrl) 
		{
			x = 100; y = 90;
			//Add background
			graphic = new Image(BKG);
			graphic.scrollX = graphic.scrollY = 0;
			graphic.visible = false;
			layer = 2;
			
			btnBat = new btnBatSelect();
			btnBat.x = 174;
			btnBat.y = 127;
			btnBat.visible = false;
			btnBat.layer = 1;
			
			btnGooba = new btnGoobaSelect()
			btnGooba.x = 425;
			btnGooba.y = 127;
			btnGooba.visible = false;
			btnGooba.layer = 1;
			
			myCamera = cam;
			//Add Buttons
		}
		
		public function startSelect():void {
			graphic.visible = true;
			btnBat.visible = true;
			btnGooba.visible = true;
		}
		
		public function endSelect():void {
			graphic.visible = false;
			btnBat.visible = false;
			btnGooba.visible = false;
		}
		
		override public function update():void {
			if (!started) {
				started = true;
				world.add(btnBat);
				world.add(btnGooba);
			}
			
			//If a button is clicked 
			if(!ScreenGame.active){
				if (btnBat.clicked) {
					btnBat.clicked = false;
					//Spawn the character
					var enemy:EnemyBase;
					enemy = new EnemyBat(myCamera.x + 400, myCamera.y);
					world.add( enemy );
					//Resume the camera
					endSelect();
					myCamera.enemyCreated(enemy);
					//Resume the game
					ScreenGame.active = true;
					spawn.play();
				}
				if (btnGooba.clicked) {
					btnGooba.clicked = false;
					var enemy:EnemyBase;
					enemy = new EnemyGooba(myCamera.x + 400, 416);
					world.add(enemy);
					endSelect();
					myCamera.enemyCreated(enemy);
					ScreenGame.active = true;
					spawn.play();
				}
			}
			
		}
	}

}