package  
{
	import net.flashpunk.Entity;
	import net.flashpunk.graphics.Image;
	import net.flashpunk.masks.Pixelmask;
	import net.flashpunk.Sfx;
	/**
	 * ...
	 * @author Lucas Lundy
	 */
	public class FireBall extends Entity
	{
		[Embed (source = 'assets/FireBall.png')] private const Fire:Class;
		[Embed(source = 'assets/FireBall.mp3')] private const FIREBALL:Class;
		[Embed(source = 'assets/FireHit.mp3')] private const FIREHIT:Class;
		
		public var FireSound:Sfx = new Sfx(FIREBALL);
		public var FireHitSfx:Sfx = new Sfx(FIREHIT);
		protected var startingX:int;
		
		public function FireBall( spawnX:int, spawnY:int) 
		{
			x = spawnX; y = spawnY;
			startingX = spawnX;
			graphic = new Image(Fire);
			mask = new Pixelmask(Fire);
			FireSound.play();
		}
		
		override public function update():void {
			
			x += 7
			
			var b:EnemyBase = collide('enemy', x, y) as EnemyBase;
				// Check if b has a value (true if a Bullet was collided with).
				if (b)
				{
					if (b.getLifeState() == EnemyBase.ALIVE){
						trace("FireBall Hit Enemy");
						b.hitGound();
						world.remove(this);
						FireHitSfx.play();
						//xVec -= 10;
					}
					//FP.world = new screenStart;
				}
				
			if (startingX - x > 400)
				world.remove(this);
		}
		
	}

}