package  
{
	import net.flashpunk.Entity;
	import net.flashpunk.graphics.Image;
	import net.flashpunk.masks.Pixelmask;
	import net.flashpunk.Sfx;
	/**
	 * ...
	 * @author Lucas Lundy
	 */
	public class Runner extends Entity
	{/*
		public var graphicGun:Image;
		public var graphicGun2:Image;*/
		//public var gunDir:String;
		//public var time:int = 0;
		//public var alive:Boolean = true;
		public static var myX:int;
		public static var myY:int;
		protected var xVec:int = 0;
		protected var yVec:int = 0;
		protected var xAccel:int = 1;
		protected var yAccel:int = -2;
		protected var maxSpeed:int = 5;
		
		public static var Health:int = 3;
		
		protected var fireCoolDown:int;
		protected var fireCoolDownDur:int = 240;
		
		protected var grounded:Boolean;
		protected var jumped:Boolean;
		protected var fireReady:Boolean;
		
		[Embed (source = 'assets/Runner01.png')] private const Runner01:Class;
		[Embed(source = 'assets/PlayerHit.mp3')] private const PLAYERHIT:Class;
		
		public var playerHitSfx:Sfx = new Sfx(PLAYERHIT);
		
		public function Runner() 
		{
			graphic = new Image(Runner01);
			addGraphic(graphic);
			mask = new Pixelmask(Runner01);
			x = 0;
			y = 192;
			
			Health = 3;
			
			type = "runner";
			
			fireReady = true;
			grounded = true;
			jumped = false;
		} 
		
		override public function update():void {
			if(ScreenGame.active){
				if (xVec < maxSpeed) {
					xVec += xAccel;
				}
				//Limit Runner 
				if (xVec > maxSpeed) {
					xVec = maxSpeed;
				}
				if (xVec < -maxSpeed) {
					xVec = -maxSpeed;
				}
				
				if (!grounded) {
					yVec += yAccel;
					var c:Ground = collide('ground', x, y) as Ground;
					// Check if b has a value (true if a Bullet was collided with).
					if (c){
						land();
					}
				}
				
				y += yVec;
				x += xVec;
				
				if (look4JumpContition()) {
					jump();
				}
				
				if (fireReady && look4FireBallCondition())
					createFireBall();
				
				if (!fireReady && fireCoolDown > fireCoolDownDur) {
					fireReady = true;
				}else
					++fireCoolDown;
				
				var b:EnemyBase = collide('enemy', x, y) as EnemyBase;
				// Check if b has a value (true if a Bullet was collided with).
				if (b)
				{
					if (b.getLifeState() == EnemyBase.ALIVE){
						trace("Player Hit Enemy");
						b.hitPlayer();
						--Health;
						playerHitSfx.play();
						xVec -= 10;
					}
					//FP.world = new screenStart;
				}
				
			}
		}
		
		protected function land():void {
			grounded = true;
			y = 192;
			yVec = 0;
		}
		
		protected function jump():void {
			yVec = -20;
			grounded = false;
			yAccel = 1;
		}
		
		public function look4JumpContition():Boolean {
			if(grounded){
				var i:int;
				var entities:Array = new Array();
				world.getType("enemy", entities);

				//var distances:Array = new Array();
				for ( i = 0; i < entities.length; i++) {
					if (entities[i].x > x + 128 && entities[i].x < x +200)
						if (entities[i].y > y + 128)
							return true;
				}
			}
			return false;
		}
		
		public function createFireBall():void {
			world.add(new FireBall(x + 150, y + 32));
			
			fireReady = false;
			fireCoolDown = 0;
		}
		
		public function look4FireBallCondition():Boolean {

			var i:int;
			var entities:Array = new Array();
			world.getType("enemy", entities);
			//var distances:Array = new Array();
			for ( i = 0; i < entities.length; i++) {
				if (entities[i].x > x + 128 && entities[i].x < x +500)
					if (entities[i].y > y && entities[i].y < y + 128)
						return true;
			}
			
			return false;
		}
		
		public function destroy():void {
			//world.remove(this);
		}
		
	}

}