package  
{
	import net.flashpunk.Entity;
	import net.flashpunk.graphics.Image;
	import net.flashpunk.FP;
	/**
	 * ...
	 * @author Lucas Lundy
	 */
	public class RunnerHealthDisplay extends Entity
	{
		protected var health1:Image;
		protected var health2:Image;
		protected var health3:Image;
		protected var health4:Image;
		protected var health5:Image;
		
		protected var curHealth:int = 5;
		
		[Embed (source = 'assets/RunnerLifeDisplay.png')] private const HEALTH_ON:Class;
		
		public function RunnerHealthDisplay() 
		{
			x = 0; y = 0;
			
			health1 = new Image(HEALTH_ON);
			health1.x = 16;
			health1.y = 16;
			health1.scrollX = health1.scrollY = 0;
			addGraphic( health1 );
			
			health2 = new Image(HEALTH_ON);
			health2.x = 32;
			health2.y = 16;
			health2.scrollX = health2.scrollY = 0;
			addGraphic( health2 );
			
			health3 = new Image(HEALTH_ON);
			health3.x = 48;
			health3.y = 16;
			health3.scrollX = health3.scrollY = 0;
			addGraphic( health3 );
			
			health4 = new Image(HEALTH_ON);
			health4.x = 64;
			health4.y = 16;
			health4.scrollX = health4.scrollY = 0;
			addGraphic( health4 );
			
			health5 = new Image(HEALTH_ON);
			health5.x = 80;
			health5.y = 16;
			health5.scrollX = health5.scrollY = 0;
			addGraphic( health5 );
		}
		
		override public function update():void {
			
			if (curHealth != Runner.Health) {
				curHealth = Runner.Health;
				switch(curHealth)
				{
				case 5: health5.alpha = 1; break;
				case 4: health3.alpha = 1; health4.alpha = 1; health5.alpha = 0.6; break;
				case 3: health2.alpha = 1; health3.alpha = 1; health4.alpha = 0.6; health5.alpha = 0.6; break;
				case 2: health1.alpha = 1; health2.alpha = 1; health3.alpha = 0.6; break;
				case 1: health1.alpha = 1; health2.alpha = 0.6; break;
				case 0: health1.alpha = 0.6; break;
				}
			}
		}
		
	}

}