package  
{
	import net.flashpunk.FP;
	import net.flashpunk.graphics.Image;
	import net.flashpunk.World;
	/**
	 * ...
	 * @author Lucas Lundy
	 */
	public class ScreenGame extends World
	{
		public static var theRunner:Runner;
		public static var theGoal:RunnerGoal;
		public static var cameraController:CameraCtrl;
		public static var lives:int = 5;
		
		public static const VICTORY:int = 0;
		public static const DEFEAT_DEATH:int = 1;
		public static const ONGOING:int = 2;
		public static const DEFEAT_GOAL:int = 3;
		
		public static var active:Boolean = true;
		public static var gameState:int;
		protected var goalSetup:Boolean;
		public var selector:EnemySelector;
		
		protected var startTime:int;
		protected var goalDur:int = 180;
		
		public function ScreenGame() 
		{
			active = true;
			gameState = ONGOING;
			goalSetup = false;
			lives = 5;

			add( new Ground(0, 448));
			add( new Ground(1028, 448));
			add( new Ground(2056, 448));
			add( new Ground(3084, 448));
			add( new Ground(4112, 448));
			add( new Ground(5140, 448));
			add( new Ground(6168, 448));
			add( new Ground(7196, 448));
			add( new Ground(8224, 448));
			add( new Ground(9252, 448));
			add( new Ground(10280, 448));
			add( new Ground(11308, 448));
			add( new Bush(500, 320));
			add( new Bush(1000, 320));
			add( new Bush(1500, 320));
			add( new Bush(2000, 320));
			add( new Bush(2500, 320));
			add( new Bush(3000, 320));
			add( new Bush(3500, 320));
			add( new Bush(4000, 320));
			add( new Bush(4500, 320));
			add( new Bush(5000, 320));
			add( new Bush(5500, 320));
			add( new Bush(6500, 320));
			add( new Bush(7000, 320));
			add( new Bush(7500, 320));
			add( new Bush(8000, 320));
			add( new Bush(8500, 320));
			add( new Bush(9000, 320));
			add( new Bush(9500, 320));
			add( new Bush(10000, 320));
			add( new Bush(10500, 320));
			add( new Bush(11000, 320));
			add( new Bush(11500, 320));
			
			theRunner = new Runner();
			add(theRunner);
			
			cameraController = new CameraCtrl(this);
			add( cameraController );
			
			theGoal = new RunnerGoal(10000, 320, this);
			add( theGoal );
			
			selector = new EnemySelector(cameraController);
			add(selector);
			
			add( new RunnerHealthDisplay() );
			
			add( new EnyLivesDisplay() );
			
			add( new ProgressIndicator() );
			
			
		}
		
		override public function update():void {
			FP.screen.color = 0x52c0ca;
			super.update();
			
			if (lives <= 0 )
				gameState = DEFEAT_DEATH;
			
			if (Runner.Health <= 0)
				gameState = VICTORY;
				
			if (gameState != ONGOING && gameState != DEFEAT_GOAL)
				FP.world = new ScreenEndGame;
				
			if (gameState == DEFEAT_GOAL) {
				if (!goalSetup) {
					goalSetup = true;
					startTime = 0;
				}
				if (startTime >= goalDur)
					FP.world = new ScreenEndGame;
				else
					++startTime;
			}
			
		}
		
		public function selectEnemy():void {
			selector.startSelect();
		}
		
		public function playerReachGoal():void {
			gameState = DEFEAT_GOAL;
		}
	}

}